#line 1 "F:/Razvoj/pic/glcd-timers-2/EDT.C"
#line 1 "f:/razvoj/pic/glcd-timers-2/edt.h"
typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int32_t;
typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long uint32_t;










typedef struct xcircle{
 uint8_t i,xc,yc,r,s;
} XCircle;

typedef struct xfillrec{
 uint8_t x,y,a,b,i,j,s;
} XFillRec;

typedef void (*EventTypeFunc)(uint8_t t, void* evp);

int16_t EventCreate(EventTypeFunc event_func, void* p, uint8_t s);
int16_t EventIPulse(uint8_t id, uint8_t type, void *msg);
int16_t EventPulse(uint8_t id, uint8_t type, void *msg);
void EventPublisherInit(int16_t msg_type, void *buff, uint8_t size);
void EventSubscribe(int16_t id, uint8_t type);
int16_t EventPublish(uint8_t type, void *msg);
int16_t EventIPublish(uint8_t type, void *msg);

void IdleSet(EventTypeFunc pfIdleFunc);

int16_t TimerCreate(int16_t tid, EventTypeFunc event_func);
int16_t TimerStart(int16_t tid,uint16_t ticks);
int16_t TimerStop(int16_t tid);
int16_t TimerNewValue(int16_t tid,uint16_t ticks);

void TimerForDispatcher(void);

void EventsInit(void);
void EventDispatcher(void);
void Check_EDT(void);
#line 56 "F:/Razvoj/pic/glcd-timers-2/EDT.C"
struct event{
 uint8_t event_type;
 uint8_t event_id;
 struct event *next;
 void *event_msg;

};

struct eventHeader{
 struct event *event_head;
 struct event *event_tail;
};

struct subscriber{

 uint8_t subscribers;
};

typedef struct timer_item{
 uint8_t status;
 uint16_t loop_ticks;
 uint16_t ticks;
 uint8_t tim_id;
 EventTypeFunc event_func;
 struct eventHeader *evList;
 struct event *tim_event;
 struct timer_item *next;
 struct timer_item *last;
} STimer;

typedef STimer *PTimer;

typedef struct eventsPool{
 struct event *ptrFreeEvItems;
 struct event irbEvItems[ 12 ];
} EventsPool;

typedef struct timersPool{
 PTimer ptrFreeTmrItems;
 STimer irbTmrItems[ 8 ];
} TimersPool;

static void EvPoolItemsInit(EventsPool *evp);
static struct event* EvPoolItemsGet(EventsPool *evp);
static struct event* EvPoolItemsGetI(EventsPool *evp);
static void EvPoolEvClose(EventsPool *evp, struct event* irbp);

static void EventsListInit(struct eventHeader* evList);
static struct event *EventIPulse1(struct eventHeader *evList, uint8_t id, uint8_t type, void *msg);
static struct event *EventPulse1(struct eventHeader *evList, uint8_t id, uint8_t type, void *msg);
static struct event *EventGet(struct eventHeader *evList);

static void TmrPoolItemsInit(TimersPool *tmrp);
static PTimer TmrPoolItemGet(TimersPool *tmrp);
static void TmrPoolItemRet(TimersPool *tmrp, PTimer irbp);
static void ClockInit(void);

static void EventQueueCreate(struct eventHeader *evHeader);
static void EventCall(struct event *ev);
static void TimerEventCall(struct event *ev);
static int16_t TimerEventCreate(EventTypeFunc event_func);

static void InterruptsInit(void);
static void TimerForDispatcher(void);
static void TimersInit(uint16_t tcountmax);
static int16_t TimerStartI(int16_t tid,uint16_t ticks);
static void EventSubscribersCall(struct event *ev);


struct eventHeader eventQueue;
EventTypeFunc myEventFunctions[ 8 ];

struct subscriber myEventSubscribers[ 10 ];


EventsPool evPool;
TimersPool tmrPool;

STimer timerHeader;
PTimer timelist=0L;

EventTypeFunc pfIdle= 0 ;

uint16_t tcnt=1, tcntmax=10;
uint8_t maska[8]={1,2,4,8,16,32,64,128};

void TimerForDispatcher(void){
 PTimer timer;
 for(timer=tmrPool.irbTmrItems; timer<tmrPool.irbTmrItems+ 8 ; timer++){
 if(timer->status ==  1 ){
 timer->ticks--;
 if(timer->ticks == 0){
 timer->tim_event=EventIPulse1(timer->evList,timer->tim_id,  102 ,  0 );
 timer->ticks = timer-> loop_ticks;
 }
 }
 }
}


void TimerForDispatcher1(void){
#line 160 "F:/Razvoj/pic/glcd-timers-2/EDT.C"
 PTimer timer;
 timer = timelist->next;
 if(timer !=  0 ){
 timer->ticks--;
 while(timer->ticks == 0){

 timer->status= 0 ;
 timer->tim_event=EventIPulse1(timer->evList,timer->tim_id,  102 ,  0 );
 timelist->next=timer->next;
 timer=timelist->next;
 if(timer== 0 ) break;
 timer->last=timelist;

 }
 }
}

static struct event* EvPoolItemsGetI(EventsPool *evp)
{
 struct event* pom;
 if(evp->ptrFreeEvItems==0L){
 pom=0L;
 }
 else{
 pom=evp->ptrFreeEvItems;
 evp->ptrFreeEvItems=evp->ptrFreeEvItems->next;
 }
 return(pom);
 }

static struct event* EvPoolItemsGet(EventsPool *evp)
 {
 struct event* pom;

 if(evp->ptrFreeEvItems==0L)
 return(0L);
  INTCON.GIE=0 ;
 pom=evp->ptrFreeEvItems;
 evp->ptrFreeEvItems=evp->ptrFreeEvItems->next;
  INTCON.GIE=1 ;
 return(pom);
 }


static void EvPoolEvClose(EventsPool *evp, struct event* irbp){
  INTCON.GIE=0 ;
 irbp->next=evp->ptrFreeEvItems;
 evp->ptrFreeEvItems=irbp;
  INTCON.GIE=1 ;
}


static void EvPoolItemsInit(EventsPool *evp){
 uint16_t i;
 struct event *tmp_irbEv;

 evp->ptrFreeEvItems = evp->irbEvItems;
 tmp_irbEv=evp->ptrFreeEvItems;
 for(i=0;i< 12 ;i++){
 if(i< 12 -1) tmp_irbEv->next=(tmp_irbEv+1);
 else tmp_irbEv->next=0L;
 tmp_irbEv++;
 }
}


static void EventsListInit(struct eventHeader* evList){
 evList->event_head=evList->event_tail =  0 ;
}

static struct event *EventIPulse1(struct eventHeader *evList, uint8_t id, uint8_t type, void *msg)
{
 struct event *new_event;

 new_event=EvPoolItemsGetI(&evPool);
 if(new_event== 0 ){
 return(new_event);
 }
 new_event->event_type=type;
 new_event->event_id=id;
 new_event->next= 0 ;
 new_event->event_msg = msg;
 if(evList->event_head ==  0 ) evList->event_head=evList->event_tail=new_event;
 else{
 evList->event_tail->next=new_event;
 evList->event_tail=new_event;
 }
 return(new_event);
}

int16_t EventIPulse(uint8_t id, uint8_t type, void *msg){

 if(EventIPulse1(&eventQueue, id, type, msg) ==  0 ) return(0);
 return(1);
}

static struct event *EventPulse1(struct eventHeader *evList, uint8_t id, uint8_t type, void *msg)
{
 struct event *new_event;

 new_event=EvPoolItemsGet(&evPool);
 if(new_event== 0 )
 return(new_event);
 new_event->event_type=type;
 new_event->event_id=id;
 new_event->event_msg = msg;
 new_event->next= 0 ;
  INTCON.GIE=0 ;
 if(evList->event_head ==  0 ) evList->event_head=evList->event_tail=new_event;
 else{
 evList->event_tail->next=new_event;
 evList->event_tail=new_event;
 }
  INTCON.GIE=1 ;
 return(new_event);
}

int16_t EventPulse(uint8_t id, uint8_t type, void *msg){


 if(EventPulse1(&eventQueue, id, type, msg) ==  0 ) return(0);
 return(1);
}

int16_t EventPublish(uint8_t type, void *msg){
 if(myEventSubscribers[type].subscribers != 0){

 if(EventPulse1(&eventQueue, 255, type, msg) ==  0 ) return(0);
 }
 else return(0);
 return(1);
}

int16_t EventIPublish(uint8_t type, void *msg){
 if(myEventSubscribers[type].subscribers != 0){

 if(EventIPulse1(&eventQueue, 255, type, msg) ==  0 ) return(0);
 }
 else return(0);
 return(1);
}

void EventPublisherInit(int16_t msg_type, void *buff, uint8_t size){

}

void EventSubscribe(int16_t id, uint8_t type){
 myEventSubscribers[type].subscribers |= maska[id];
}

static struct event *EventGet(struct eventHeader *evList){
 struct event *new_event;

  INTCON.GIE=0 ;
 new_event=evList->event_head;

 if(evList->event_head== 0 ) evList->event_tail= 0 ;
 else evList->event_head=evList->event_head->next;
  INTCON.GIE=1 ;

 return(new_event);
}

static PTimer TmrPoolItemGet(TimersPool *tmrp){
 PTimer pom;
 if(tmrp->ptrFreeTmrItems==0L) return(0L);
 pom=tmrp->ptrFreeTmrItems;
 tmrp->ptrFreeTmrItems=tmrp->ptrFreeTmrItems->next;

 return(pom);
 }

static void TmrPoolItemRet(TimersPool *tmrp, PTimer irbp){
 irbp->next=tmrp->ptrFreeTmrItems;
 tmrp->ptrFreeTmrItems=irbp;
}


static void TmrPoolItemsInit(TimersPool *tmrp){
 uint16_t i;
 PTimer tmp_irbTmr;

 tmrp->ptrFreeTmrItems = tmrp->irbTmrItems;
 tmp_irbTmr=tmrp->ptrFreeTmrItems;
 for(i=0;i< 8 ;i++){
 if(i< 8 -1) tmp_irbTmr->next=(tmp_irbTmr+1);
 else tmp_irbTmr->next=0L;
 tmp_irbTmr++;
 }
 }

static void ClockInit(void){
 timelist=&timerHeader;
 timelist->next=timelist->last= 0 ;
 timelist->ticks=0;
 timelist->status= 1 ;
 timelist->tim_id=0;
 timelist->evList= 0 ;
 timelist->tim_event= 0 ;
}

int16_t TimerCreate(int16_t tid, EventTypeFunc event_func)
{
 PTimer timer;

 timer = tmrPool.irbTmrItems + tid;
 if (timer== 0 ) return(-1);
 timer->event_func=event_func;
 timer->status= 0 ;
 timer->ticks=0;
 timer->loop_ticks=0;
 timer->tim_id=tid;
 timer->evList=&eventQueue;
 timer->tim_event= 0 ;
 return 1;
}

int16_t TimerStart(int16_t tid,uint16_t ticks){
 PTimer timer;

 timer = (PTimer)((tmrPool.irbTmrItems)+tid);
 if(timer->status== 1  || timer== 0 ) return(0);
 timer->status= 1 ;
 timer->ticks=ticks;
 timer->loop_ticks=ticks;
 timer->tim_event= 0 ;
 return(1);
}

static int16_t TimerStartI(int16_t tid,uint16_t ticks){
 PTimer timer, current;

 timer = (PTimer)((tmrPool.irbTmrItems)+tid);
 if(timer->status== 1  || timer== 0 ) return(0);
 timer->status= 1 ;
 timer->ticks=ticks;
 timer->loop_ticks=ticks;
 timer->tim_event= 0 ;
 current=timelist;

 while(timer->ticks >= current->ticks && current->next !=  0 ){
 timer->ticks-=current->ticks;
 current=current->next;
 }
 if(timer->ticks < current->ticks){
 current->ticks-=timer->ticks;
 timer->next=current;
 timer->last=current->last;
 current->last=timer;
 timer->last->next=timer;
 }
 else{
 timer->ticks-=current->ticks;
 timer->next= 0 ;
 timer->last=current;
 current->next=timer;
 }

 return(1);
}

int16_t TimerStop(int16_t tid){
 PTimer timer;

 timer = (PTimer)((tmrPool.irbTmrItems)+tid);
 if (timer== 0 ) return(0);
  INTCON.GIE=0 ;
 if(timer->status== 1 ){
 timer->status= 0 ;
 timer->tim_event= 0 ;
 }
  INTCON.GIE=1 ;
 return(1);
}

int16_t TimerNewValue(int16_t tid,uint16_t ticks){
 PTimer timer;

 timer = (PTimer)((tmrPool.irbTmrItems)+tid);
 if(timer== 0 ) return(0);
 timer->loop_ticks=ticks;
 return(1);
}

static void EventQueueCreate(struct eventHeader *evHeader){
 EvPoolItemsInit(&evPool);
 TmrPoolItemsInit(&tmrPool);
 EventsListInit(evHeader);
 ClockInit();
}

int16_t EventCreate(EventTypeFunc event_func, void* p, uint8_t s){
 static int16_t eid=-1;

 eid++;
 if(eid >=  8 ) return (-1);
 myEventFunctions[eid]=event_func;


 return eid;
}

static void EventCall(struct event *ev){


 (*myEventFunctions[ev->event_id])(ev->event_type, ev->event_msg);
}

static void TimerEventCall(struct event *ev){
 EventTypeFunc f1;
 f1=(tmrPool.irbTmrItems)[ev->event_id].event_func;
 (*f1)(0,ev->event_msg);
}

static void EventSubscribersCall(struct event *ev){
 int16_t i;







 for(i=0; i<8; i++)
 {
 if((maska[i] & myEventSubscribers[ev->event_type].subscribers) != 0x00)
 {
 (*myEventFunctions[i])(ev->event_type, ev->event_msg);
 }
 }
}

void EventDispatcher(void){
 struct event *ev;
 uint8_t eid;

 do {
 ev = EventGet(&eventQueue);
 eid = ev->event_id;
 if(ev !=  0 ){
 if(ev->event_type ==  102 ){
 TimerEventCall(ev);


 }
 else if(ev->event_type ==  103 ){
 }
 else{
 if(ev->event_id == 255){
 EventSubscribersCall(ev);
 }
 else{
 EventCall(ev);

 }
 }
 EvPoolEvClose(&evPool, ev);
 }
 else{
 if(pfIdle !=  0 ){
 (*pfIdle)(0, 0 );
 }
 }

 } while(1);
}

void Check_EDT(void){
 struct event *ev;
 uint8_t eid;

 ev = EventGet(&eventQueue);
 eid = ev->event_id;
 if(ev !=  0 ){
 if(ev->event_type ==  102 ){
 TimerEventCall(ev);


 }
 else if(ev->event_type ==  103 ){
 }
 else{
 if(ev->event_id == 255){
 EventSubscribersCall(ev);
 }
 else{
 EventCall(ev);

 }
 }
 EvPoolEvClose(&evPool, ev);
 }
 else{
 if(pfIdle !=  0 ){
 (*pfIdle)(0, 0 );
 }
 }
}

void EventsInit(void){

 EventQueueCreate(&eventQueue);




}

void IdleSet(EventTypeFunc pfIdleFunc){
 pfIdle = pfIdleFunc;
}
