typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int32_t;
typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long uint32_t;

#ifdef __cplusplus          /* C++ */
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

#define disable() INTCON.GIE=0
#define enable()   INTCON.GIE=1

typedef struct xcircle{
   uint8_t i,xc,yc,r,s;
} XCircle;

typedef struct xfillrec{
   uint8_t x,y,a,b,i,j,s;
} XFillRec;

typedef void (*EventTypeFunc)(uint8_t t, void* evp);

int16_t EventCreate(EventTypeFunc event_func, void* p, uint8_t s);
int16_t EventIPulse(uint8_t id, uint8_t type, void *msg);
int16_t EventPulse(uint8_t id, uint8_t type, void *msg);
void EventPublisherInit(int16_t msg_type, void *buff, uint8_t size);
void EventSubscribe(int16_t id, uint8_t type);
int16_t EventPublish(uint8_t type, void *msg);
int16_t EventIPublish(uint8_t type, void *msg);

void IdleSet(EventTypeFunc pfIdleFunc);

int16_t TimerCreate(int16_t tid, EventTypeFunc event_func);
int16_t TimerStart(int16_t tid,uint16_t ticks);
int16_t TimerStop(int16_t tid);
int16_t TimerNewValue(int16_t tid,uint16_t ticks);
//void TimerForDispatcher1(void);
void TimerForDispatcher(void);

void EventsInit(void);
void EventDispatcher(void);
void Check_EDT(void);
//void Start_EDT(void);